﻿Imports System.Drawing.Printing

Public Class Form1

    'definizione di un button
    Private WithEvents Button1 As New Button

    'definizione di un documento di stampa
    Private WithEvents PrintDocument1 As New PrintDocument

    'definizione di un nuovo font
    Private NuovoFont As Font

    'definizione della variabile che contiene il testo
    Dim Testo As String

    'definizione del formato del testo
    Dim CustomFormat As New StringFormat

    'inizializzazione dei componenti Form e Button
    Public Sub New()

        InitializeComponent()

        'imposta la form
        Me.Size = New Size(210, 180)
        Me.Text = "Stampa Testo"

        'imposta il button
        Button1.Size = New Size(100, 30)
        Button1.Location = New Point(51, 58)
        Button1.Text = "Stampa"

        'aggiunge il button alla form
        Me.Controls.Add(Button1)

    End Sub

    Private Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click

        'stampa diretta del documento senza attivare finestre di dialogo
        PrintDocument1.Print()

    End Sub

    'Inpostazioni iniziali prima dell'avvio del processo di stampa
    Private Sub PrintDocument1_BeginPrint1(ByVal sender As Object, ByVal e As  _
    System.Drawing.Printing.PrintEventArgs) Handles PrintDocument1.BeginPrint

        Testo = "Stampare del semplice testo con allineamento sinistro, destro o centrato è " + _
        "un’operazione piuttosto semplice." + " E’ sufficiente avere uno scritto da passare " + _
        "alla stampante e decidere il tipo di formattazione desiderata e il gioco è fatto."

        NuovoFont = New Font("Times New Roman", 12, FontStyle.Bold, GraphicsUnit.Point)

        'allineamento verticale: vicino (near) al margine superiore
        CustomFormat.LineAlignment = StringAlignment.Near

        'allineamento orizzontale: vicino (near) al margine sinistro
        CustomFormat.Alignment = StringAlignment.Near

    End Sub

    Private Sub PrintDocument1_PrintPage1(ByVal sender As Object, ByVal e As  _
    System.Drawing.Printing.PrintPageEventArgs) Handles PrintDocument1.PrintPage

        'disegna il testo da stampare
        e.Graphics.DrawString(Testo, NuovoFont, Brushes.Black, e.MarginBounds, CustomFormat)

    End Sub

    Private Sub PrintDocument1_EndPrint1(ByVal sender As Object, ByVal e _
    As System.Drawing.Printing.PrintEventArgs) Handles PrintDocument1.EndPrint

        'rilascia le isorse occupate dal testo
        NuovoFont.Dispose()
        NuovoFont = Nothing

    End Sub

End Class
